CREATE OR REPLACE PROCEDURE ARQUIVO_GISS_ONLINE(
   P_NRLISTA      IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_CABECALHO    VARCHAR2(800);
   V_ISSQN_E      VARCHAR2(02);
   V_ISSQN_RET_E  VARCHAR2(02);
   V_ISSQN_S      VARCHAR2(02);
   V_ISSQN_RET_S  VARCHAR2(02);
   V_CONTADOR     NUMBER;
   CDCLASSERVPADR VARCHAR2(02);
   P_CDINSCESTA   VARCHAR2(02);
   P_CDINSCMUNI   VARCHAR2(02);

BEGIN
   /*Impostos utilizados no arquivo*/
   V_ISSQN_E     := '30';
   V_ISSQN_RET_E := '35';
   V_ISSQN_S     := '31';
   V_ISSQN_RET_S := '36';
   V_CONTADOR    := 0;


   /*Registro de Cabealho, que indica a ordem dos Campos*/
   V_CABECALHO := 'CD_INDICADOR'                 || '||' ||    'NR_LAYOUT'                    || '||' ||
                  'DT_EMISSAO_NF'                || '||' ||    'NR_DOC_NF_INICIAL'            || '||' ||
                  'NR_DOC_NF_SERIE'              || '||' ||    'NR_DOC_NF_FINAL'              || '||' ||
                  'TP_DOC_NF'                    || '||' ||    'VL_DOC_NF'                    || '||' ||
                  'VL_BASE_CALCULO'              || '||' ||    'CD_ATIVIDADE'                 || '||' ||
                  'CD_PREST_TOM_ESTABELECIDO'    || '||' ||    'CD_LOCAL_PRESTACAO'           || '||' ||
                  'NM_RAZAO_SOCIAL'              || '||' ||    'NR_CNPJ_CPF'                  || '||' ||
                  'CD_TIPO_CADASTRO'             || '||' ||    'NR_INSCRICAO_MUNICIPAL'       || '||' ||
                  'NM_INSCRICAO_MUNICIPAL_DV'    || '||' ||    'NR_INSCRICAO_ESTADUAL'        || '||' ||
                  'NM_TIPO_LOGRADOURO'           || '||' ||    'NM_TITULO_LOGRADOURO'         || '||' ||
                  'NM_LOGRADOURO'                || '||' ||    'NM_COMPL_LOGRADOURO'          || '||' ||
                  'NR_LOGRADOURO'                || '||' ||    'CD_CEP'                       || '||' ||
                  'NM_BAIRRO'                    || '||' ||    'CD_ESTADO'                    || '||' ||
                  'NM_CIDADE'                    || '||' ||    'CD_PAIS'                      || '||' ||
                  'NM_OBSERVACAO'                || '||' ||    'CD_PLANO_CONTA'               || '||' ||
                  'CD_ALVARA'                    || '||' ||    'IC_ORIGEM_DADOS'              || '||' ||
                  'IC_ENQUADRAMENTO'             || '||' ||    'CD_PLANO_CONTA_PAI'           || '||' ||
                  'IC_RECOLHE_IMPOSTO'           || '||' ||    'VL_ALIQUOTA'                  || '||' ||
                  'FL_ISENTO'                    || '||' ||    'FL_SIMPLES';

     V_CONTADOR := NVL(V_CONTADOR,0)+1;
     INSERT INTO ARQMAGNETICO
       (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
     VALUES
       (LPAD(V_CONTADOR,10,'0'), V_CABECALHO, P_NRSEQARQMAG);

     /*Servios Tomados, modalidades T1 e F4*/
     /*Servio Tomado de Prestador Residente no Pas Com Nota Fiscal (T|1)*/
     FOR C_REG_T1 IN (SELECT CD_INDICADOR                 || '||' ||    NR_LAYOUT                || '||' ||
                             DT_EMISSAO_NF                || '||' ||    NR_DOC_NF_INICIAL        || '||' ||
                             NR_DOC_NF_SERIE              || '||' ||    ''                       || '||' ||
                             CASE WHEN IDSTATUS = 'C'      THEN '2' --Cancelado
                                  WHEN VR_IMP > 0          THEN '1' --No Retido
                                  WHEN VR_RET > 0          THEN '5' --Retido
                                  WHEN (VR_IMP+VR_RET) = 0 THEN '4' --Isenta
                             END                          || '||' ||    VL_DOC_NF                || '||' ||
                             ''                           || '||' ||    CD_ATIVIDADE             || '||' ||
                             CD_PREST_TOM_ESTABELECIDO    || '||' ||    CD_LOCAL_PRESTACAO       || '||' ||
                             NM_RAZAO_SOCIAL              || '||' ||    NR_CNPJ_CPF              || '||' ||
                             CD_TIPO_CADASTRO             || '||' ||    NR_INSCRICAO_MUNICIPAL   || '||' ||
                             NM_INSCRICAO_MUNICIPAL_DV    || '||' ||    NR_INSCRICAO_ESTADUAL    || '||' ||
                             NM_TIPO_LOGRADOURO           || '||' ||    NM_TITULO_LOGRADOURO     || '||' ||
                             NM_LOGRADOURO                || '||' ||    NM_COMPL_LOGRADOURO      || '||' ||
                             NR_LOGRADOURO                || '||' ||    CD_CEP                   || '||' ||
                             NM_BAIRRO                    || '||' ||    CD_ESTADO                || '||' ||
                             NM_CIDADE                    || '||' ||    ''                       || '||' ||
                             ''                           || '||' ||    ''                       || '||' ||
                             ''                           || '||' ||    IC_ORIGEM_DADOS          || '||' ||
                             ''                           || '||' ||    ''                       || '||' ||
                             ''                           || '||' ||    DECODE(FL_SIMPLES,'N','',ALIQUOTA) || '||' ||
                             FL_ISENTO                    || '||' ||    FL_SIMPLES               AS DADOS,
                             NRLANCTONF, CDFILIAL
                        FROM (SELECT NF.NRLANCTONF, NF.CDFILIAL, 'T' AS CD_INDICADOR, '1' AS NR_LAYOUT,
                                     TO_CHAR(NF.DTENTRSAID,'DD')||'/'||TO_CHAR(NF.DTENTRSAID,'MM')||'/'||TO_CHAR(NF.DTENTRSAID,'YYYY') AS DT_EMISSAO_NF,
                                     LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_INICIAL, NF.CDSERIEENTR AS NR_DOC_NF_SERIE,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_E,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_IMP,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_RET_E,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_RET,
                                     MAX(IT.VRALIQITEM) AS ALIQUOTA, NF.IDSTATUS,
                                     TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')) AS VL_DOC_NF,
                                     MAX(CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI)) AS CD_ATIVIDADE,
                                     DECODE(FO.IDTPIJURFORN,'F','1','2') AS CD_TIPO_CADASTRO,
                                     DECODE(EF.CDMUNICIPIO,IC.CDMUNICIPIO,'S','N') AS CD_PREST_TOM_ESTABELECIDO,
                                     FO.NMRAZSOCFORN AS NM_RAZAO_SOCIAL, REPLACE(REPLACE(FO.NRINSMUNFORN,'ISENTA'),'ISENTO') AS NR_INSCRICAO_MUNICIPAL,
                                     '' AS NM_INSCRICAO_MUNICIPAL_DV, FO.NRINSJURFORN AS NR_CNPJ_CPF,
                                     CASE WHEN FO.NRINSESTFORN IS NULL OR NRINSESTFORN = '' THEN 'S' ELSE 'N' END AS FL_ISENTO,
                                     REPLACE(REPLACE(FO.NRINSESTFORN,'ISENTA'),'ISENTO') AS NR_INSCRICAO_ESTADUAL, REPLACE(REPLACE(EF.NRCEPFORN,'.'),'-') AS CD_CEP,
                                     TRIM(SUBSTR(EF.DSENDEFORN,1,INSTR(EF.DSENDEFORN,' '))) AS NM_TIPO_LOGRADOURO,
                                     TRIM(REPLACE(SUBSTR(EF.DSENDEFORN,INSTR(EF.DSENDEFORN,' '),(INSTR(EF.DSENDEFORN,' ', -1)-INSTR(EF.DSENDEFORN,' '))),',')) AS NM_LOGRADOURO,
                                     TRIM(SUBSTR(EF.DSENDEFORN,INSTR(EF.DSENDEFORN,' ', -1),LENGTH(EF.DSENDEFORN))) AS NR_LOGRADOURO,
                                     '' AS NM_TITULO_LOGRADOURO, EF.DSCOMPENDFOR AS NM_COMPL_LOGRADOURO,
                                     EF.NMBAIRFORN AS NM_BAIRRO, EF.SGESTADO AS CD_ESTADO,
                                     MU.NMMUNICIPIO AS NM_CIDADE, DECODE(EF.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F') AS CD_LOCAL_PRESTACAO,
                                     NVL(PF.IDSIMPLESNACIONAL,'N') AS FL_SIMPLES, 'R' AS IC_ORIGEM_DADOS
                                FROM LISTA LS, NOTAFISCAL NF, ITEMPROIMPOS IT, IMPOSTO IM, ITEMPRODUTO IP, PRODUTO PR,
                                     FORNECEDOR FO, ENDEFORN EF, INSCRMUNICIP IC, MUNICIPIO MU, PARAMFORNE PF
                               WHERE LS.NRLISTA      = P_NRLISTA
                                 AND SUBSTR(LS.CDLISTA,1,4)  = NF.CDFILIAL
                                 AND SUBSTR(LS.CDLISTA,5,10) = NF.NRLANCTONF
                                 AND NF.IDENTRSAIDOP = 'E'
                                 AND NF.CDFILIAL     = IT.CDFILIAL
                                 AND NF.NRLANCTONF   = IT.NRLANCTONF
                                 AND SUBSTR(IT.CDFISCOPERIT,1,1) <> '3'
                                 AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                 AND IM.CDIMPOSTONFE IN (V_ISSQN_E, V_ISSQN_RET_E)
                                 AND IT.NRLANCTONF   = IP.NRLANCTONF
                                 AND IT.CDFILIAL     = IP.CDFILIAL
                                 AND IT.NRSEQITPROD  = IP.NRSEQITPROD
                                 AND IP.CDPRODUTO    = PR.CDPRODUTO
                                 AND NF.CDFORNECED   = FO.CDFORNECED
                                 AND NF.CDFORNECED   = EF.CDFORNECED
                                 AND EF.IDTPENDEFORN = 'P'
                                 AND NF.CDEMPRESA    = IC.CDEMPRESA
                                 AND NF.CDINSCMUNI   = IC.CDINSCMUNI
                                 AND EF.CDPAIS       = MU.CDPAIS
                                 AND EF.SGESTADO     = MU.SGESTADO
                                 AND EF.CDMUNICIPIO  = MU.CDMUNICIPIO
                                 AND EF.CDFORNECED   = PF.CDFORNECED(+)
                               GROUP BY NF.NRLANCTONF, NF.CDFILIAL,
                                        TO_CHAR(NF.DTENTRSAID,'DD')||'/'||TO_CHAR(NF.DTENTRSAID,'MM')||'/'||TO_CHAR(NF.DTENTRSAID,'YYYY'),
                                        LPAD(NF.NRNOTAFISC,10,'0'), NF.CDSERIEENTR, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')),
                                        DECODE(FO.IDTPIJURFORN,'F','1','2'), DECODE(EF.CDMUNICIPIO,IC.CDMUNICIPIO,'S','N'),
                                        FO.NMRAZSOCFORN, FO.NRINSMUNFORN, FO.NRINSJURFORN, NF.IDSTATUS,
                                        CASE WHEN FO.NRINSESTFORN IS NULL OR NRINSESTFORN = '' THEN 'S' ELSE 'N' END,
                                        FO.NRINSESTFORN, EF.NRCEPFORN, TRIM(SUBSTR(EF.DSENDEFORN,1,INSTR(EF.DSENDEFORN,' '))),
                                        TRIM(REPLACE(SUBSTR(EF.DSENDEFORN,INSTR(EF.DSENDEFORN,' '),(INSTR(EF.DSENDEFORN,' ', -1)-INSTR(EF.DSENDEFORN,' '))),',')),
                                        TRIM(SUBSTR(EF.DSENDEFORN,INSTR(EF.DSENDEFORN,' ', -1),LENGTH(EF.DSENDEFORN))), EF.DSCOMPENDFOR, EF.NMBAIRFORN,
                                        EF.SGESTADO, MU.NMMUNICIPIO, DECODE(EF.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F'), NVL(PF.IDSIMPLESNACIONAL,'N'))) LOOP

        V_CONTADOR := NVL(V_CONTADOR,0)+1;
        INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
          (LPAD(V_CONTADOR,10,'0'), C_REG_T1.DADOS , P_NRSEQARQMAG);

        UPDATE NOTAFISCAL
           SET IDEXPNFEISS = 'S'
         WHERE CDFILIAL    = C_REG_T1.CDFILIAL
           AND NRLANCTONF  = C_REG_T1.NRLANCTONF;
     END LOOP;

     /*Servio Tomado de Prestador Residente Fora do Pas Com Nota Fiscal (F|4)*/
     FOR C_REG_F4 IN (SELECT CD_INDICADOR       || '||' ||    NR_LAYOUT             || '||' ||
                             DT_EMISSAO_NF      || '||' ||    NR_DOC_NF_INICIAL     || '||' ||
                             NR_DOC_NF_SERIE    || '||' ||    ''                    || '||' ||
                             CASE WHEN IDSTATUS = 'C'      THEN '2' --Cancelado
                                  WHEN VR_IMP > 0          THEN '1' --No Retido
                                  WHEN VR_RET > 0          THEN '5' --Retido
                                  WHEN (VR_IMP+VR_RET) = 0 THEN '4' --Isenta
                             END                || '||' ||    VL_DOC_NF             || '||' ||
                             ''                 || '||' ||    CD_ATIVIDADE          || '||' ||
                             ''                 || '||' ||    CD_LOCAL_PRESTACAO    || '||' ||
                             NM_RAZAO_SOCIAL    || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    CD_PAIS               || '||' ||
                             NM_OBSERVACAO      || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    IC_ORIGEM_DADOS       || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    || '||' ||
                             ''                 || '||' ||    ''                    AS DADOS,
                             NRLANCTONF, CDFILIAL
                        FROM (SELECT NF.NRLANCTONF, NF.CDFILIAL, 'F' AS CD_INDICADOR, '4' AS NR_LAYOUT,
                                     TO_CHAR(NF.DTENTRSAID,'DD')||'/'||TO_CHAR(NF.DTENTRSAID,'MM')||'/'||TO_CHAR(NF.DTENTRSAID,'YYYY') AS DT_EMISSAO_NF,
                                     LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_INICIAL, NF.CDSERIEENTR AS NR_DOC_NF_SERIE,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_E,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_IMP,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_RET_E,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_RET,
                                     NF.IDSTATUS , TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')) AS VL_DOC_NF,
                                     MAX(CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI)) AS CD_ATIVIDADE, 'D' AS CD_LOCAL_PRESTACAO, FO.NMRAZSOCFORN AS NM_RAZAO_SOCIAL,
                                     SUBSTR(NVL(P.SGPAIS,P.NMPAIS),1,2) AS CD_PAIS, '' AS NM_OBSERVACAO, 'R' AS IC_ORIGEM_DADOS
                                FROM LISTA LS, NOTAFISCAL NF, ITEMPROIMPOS IT, IMPOSTO IM, ITEMPRODUTO IP, PRODUTO PR,
                                     FORNECEDOR FO, ENDEFORN EF, PAIS P
                               WHERE LS.NRLISTA      = P_NRLISTA
                                 AND SUBSTR(LS.CDLISTA,1,4)  = NF.CDFILIAL
                                 AND SUBSTR(LS.CDLISTA,5,10) = NF.NRLANCTONF
                                 AND NF.IDENTRSAIDOP = 'E'
                                 AND NF.CDFILIAL     = IT.CDFILIAL
                                 AND NF.NRLANCTONF   = IT.NRLANCTONF
                                 AND SUBSTR(IT.CDFISCOPERIT,1,1) = '3'
                                 AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                 AND IM.CDIMPOSTONFE IN (V_ISSQN_E, V_ISSQN_RET_E)
                                 AND IT.NRLANCTONF   = IP.NRLANCTONF
                                 AND IT.CDFILIAL     = IP.CDFILIAL
                                 AND IT.NRSEQITPROD  = IP.NRSEQITPROD
                                 AND IP.CDPRODUTO    = PR.CDPRODUTO
                                 AND NF.CDFORNECED   = FO.CDFORNECED
                                 AND NF.CDFORNECED   = EF.CDFORNECED
                                 AND EF.IDTPENDEFORN = 'P'
                                 AND EF.CDPAIS       = P.CDPAIS
                               GROUP BY NF.NRLANCTONF, NF.CDFILIAL,
                                        TO_CHAR(NF.DTENTRSAID,'DD')||'/'||TO_CHAR(NF.DTENTRSAID,'MM')||'/'||TO_CHAR(NF.DTENTRSAID,'YYYY'),
                                        LPAD(NF.NRNOTAFISC,10,'0'), NF.CDSERIEENTR, NF.IDSTATUS, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')),
                                        FO.NMRAZSOCFORN, SUBSTR(NVL(P.SGPAIS,P.NMPAIS),1,2))) LOOP

        V_CONTADOR := NVL(V_CONTADOR,0)+1;
        INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
          (LPAD(V_CONTADOR,10,'0'), C_REG_F4.DADOS, P_NRSEQARQMAG);

        UPDATE NOTAFISCAL
           SET IDEXPNFEISS = 'S'
         WHERE CDFILIAL    = C_REG_F4.CDFILIAL
           AND NRLANCTONF  = C_REG_F4.NRLANCTONF;
     END LOOP;

     /*Servios Prestados, modalidades C1, C2 e C3*/
     /*Servio Prestado para Pessoa Fsica (C|1)*/
     FOR C_REG_C1 IN (SELECT CD_INDICADOR        || '||' ||    NR_LAYOUT           || '||' ||
                             DT_EMISSAO_NF       || '||' ||    NR_DOC_NF_INICIAL   || '||' ||
                             NR_DOC_NF_SERIE     || '||' ||    NR_DOC_NF_FINAL     || '||' ||
                             CASE WHEN IDSTATUS = 'C'      THEN '2' --Cancelado
                                  WHEN VR_IMP > 0          THEN '1' --No Retido
                                  WHEN VR_RET > 0          THEN '5' --Retido
                                  WHEN (VR_IMP+VR_RET) = 0 THEN '4' --Isento
                             END                 || '||' ||    VL_DOC_NF           || '||' ||
                             ''                  || '||' ||    CD_ATIVIDADE        || '||' ||
                             ''                  || '||' ||    CD_LOCAL_PRESTACAO  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             CD_TIPO_CADASTRO    || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    IC_ORIGEM_DADOS     || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  || '||' ||
                             ''                  || '||' ||    ''                  AS DADOS,
                             NRLANCTONF, CDFILIAL
                        FROM (SELECT NF.NRLANCTONF, NF.CDFILIAL, 'C' AS CD_INDICADOR, '1' AS NR_LAYOUT, NF.CDSERIE AS NR_DOC_NF_SERIE,
                                     LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_INICIAL, LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_FINAL,
                                     TO_CHAR(NF.DTEMISSAO,'DD')||'/'||TO_CHAR(NF.DTEMISSAO,'MM')||'/'||TO_CHAR(NF.DTEMISSAO,'YYYY') AS DT_EMISSAO_NF,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_S,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_IMP,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_RET_S,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_RET,
                                     NF.IDSTATUS, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')) AS VL_DOC_NF,
                                     MAX(CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI)) AS CD_ATIVIDADE, '1' AS CD_TIPO_CADASTRO,
                                     DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F') AS CD_LOCAL_PRESTACAO, 'R' AS IC_ORIGEM_DADOS
                                FROM LISTA LS, NOTAFISCAL NF, IMPOSTO IM, ITEMPROIMPOS IT, ITEMPRODUTO IP, PRODUTO PR,
                                     CLIENTE CL, ENDECLIE EC, INSCRMUNICIP IC
                               WHERE LS.NRLISTA      = P_NRLISTA
                                 AND SUBSTR(LS.CDLISTA,1,4)  = NF.CDFILIAL
                                 AND SUBSTR(LS.CDLISTA,5,10) = NF.NRLANCTONF
                                 AND NF.IDENTRSAIDOP = 'S'
                                 AND NF.NRLANCTONF   = IT.NRLANCTONF
                                 AND NF.CDFILIAL     = IT.CDFILIAL
                                 AND SUBSTR(IT.CDFISCOPERIT,1,1) <> '7'
                                 AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                 AND IM.CDIMPOSTONFE IN (V_ISSQN_S, V_ISSQN_RET_S)
                                 AND IT.NRLANCTONF   = IP.NRLANCTONF
                                 AND IT.CDFILIAL     = IP.CDFILIAL
                                 AND IT.NRSEQITPROD  = IP.NRSEQITPROD
                                 AND IP.CDPRODUTO    = PR.CDPRODUTO
                                 AND NF.CDCLIENTE    = CL.CDCLIENTE
                                 AND CL.IDTPIJURCLIE = 'F'
                                 AND NF.CDCLIENTE    = EC.CDCLIENTE
                                 AND EC.IDTPENDECLIE = 'P'
                                 AND NF.CDEMPRESA    = IC.CDEMPRESA
                                 AND NF.CDINSCMUNI   = IC.CDINSCMUNI
                               GROUP BY NF.NRLANCTONF, NF.CDFILIAL, NF.CDSERIE, LPAD(NF.NRNOTAFISC,10,'0'),
                                        TO_CHAR(NF.DTEMISSAO,'DD')||'/'||TO_CHAR(NF.DTEMISSAO,'MM')||'/'||TO_CHAR(NF.DTEMISSAO,'YYYY'),
                                        NF.IDSTATUS, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')),
                                        DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F'))) LOOP

        V_CONTADOR := NVL(V_CONTADOR,0)+1;
        INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
          (LPAD(V_CONTADOR,10,'0'), C_REG_C1.DADOS, P_NRSEQARQMAG);

        UPDATE NOTAFISCAL
           SET IDEXPNFEISS = 'S'
         WHERE CDFILIAL    = C_REG_C1.CDFILIAL
           AND NRLANCTONF  = C_REG_C1.NRLANCTONF;
     END LOOP;

     /*Servio Prestado para Tomador Fora do Pas (C|2)*/
     FOR C_REG_C2 IN (SELECT CD_INDICADOR               || '||' ||    NR_LAYOUT             || '||' ||
                             DT_EMISSAO_NF              || '||' ||    NR_DOC_NF_INICIAL     || '||' ||
                             NR_DOC_NF_SERIE            || '||' ||    NR_DOC_NF_FINAL       || '||' ||
                             CASE WHEN IDSTATUS = 'C'      THEN '2'  --Cancelado
                                  WHEN VR_IMP > 0          THEN '1'  --No Retido
                                  WHEN VR_RET > 0          THEN '5'  --Retido
                                  WHEN (VR_IMP+VR_RET) = 0 THEN '4'  --Isento
                             END                        || '||' ||    VL_DOC_NF             || '||' ||
                             ''                         || '||' ||    CD_ATIVIDADE          || '||' ||
                             CD_PREST_TOM_ESTABELECIDO  || '||' ||    CD_LOCAL_PRESTACAO    || '||' ||
                             NM_RAZAO_SOCIAL            || '||' ||    ''                    || '||' ||
                             CD_TIPO_CADASTRO           || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    CD_PAIS               || '||' ||
                             NM_OBSERVACAO              || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    IC_ORIGEM_DADOS       || '||' ||
                             ''                         || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    ''                    || '||' ||
                             ''                         || '||' ||    ''                    AS DADOS,
                             NRLANCTONF, CDFILIAL
                        FROM (SELECT NF.NRLANCTONF, NF.CDFILIAL, 'C' AS CD_INDICADOR, '2' AS NR_LAYOUT, LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_INICIAL,
                                     NF.CDSERIE AS NR_DOC_NF_SERIE, LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_FINAL,
                                     TO_CHAR(NF.DTEMISSAO,'DD')||'/'||TO_CHAR(NF.DTEMISSAO,'MM')||'/'||TO_CHAR(NF.DTEMISSAO,'YYYY') AS DT_EMISSAO_NF,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_S,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_IMP,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_RET_S,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_RET,
                                     NF.IDSTATUS, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')) AS VL_DOC_NF,
                                     MAX(CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI)) AS CD_ATIVIDADE, DECODE(CL.IDTPIJURCLIE,'F','1','2') AS CD_TIPO_CADASTRO,
                                     DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'S','N') AS CD_PREST_TOM_ESTABELECIDO,
                                     SUBSTR(NVL(P.SGPAIS,P.NMPAIS),1,2) AS CD_PAIS, CL.NMRAZSOCCLIE AS NM_RAZAO_SOCIAL, '' AS NM_OBSERVACAO,
                                     DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F') AS CD_LOCAL_PRESTACAO, 'R' AS IC_ORIGEM_DADOS
                                FROM LISTA LS, NOTAFISCAL NF, ITEMPROIMPOS IT, IMPOSTO IM, ITEMPRODUTO IP, PRODUTO PR,
                                     CLIENTE CL, ENDECLIE EC, INSCRMUNICIP IC, PAIS P
                               WHERE LS.NRLISTA      = P_NRLISTA
                                 AND SUBSTR(LS.CDLISTA,1,4) = NF.CDFILIAL
                                 AND SUBSTR(LS.CDLISTA,5,10)= NF.NRLANCTONF
                                 AND NF.IDENTRSAIDOP = 'S'
                                 AND NF.NRLANCTONF   = IT.NRLANCTONF
                                 AND NF.CDFILIAL     = IT.CDFILIAL
                                 AND SUBSTR(IT.CDFISCOPERIT,1,1) = '7'
                                 AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                 AND IM.CDIMPOSTONFE IN (V_ISSQN_S, V_ISSQN_RET_S)
                                 AND IT.NRLANCTONF   = IP.NRLANCTONF
                                 AND IT.CDFILIAL     = IP.CDFILIAL
                                 AND IT.NRSEQITPROD  = IP.NRSEQITPROD
                                 AND IP.CDPRODUTO    = PR.CDPRODUTO
                                 AND NF.CDCLIENTE    = CL.CDCLIENTE
                                 AND NF.CDCLIENTE    = EC.CDCLIENTE
                                 AND EC.IDTPENDECLIE = 'P'
                                 AND NF.CDEMPRESA    = IC.CDEMPRESA
                                 AND NF.CDINSCMUNI   = IC.CDINSCMUNI
                                 AND EC.CDPAIS       = P.CDPAIS
                               GROUP BY NF.NRLANCTONF, NF.CDFILIAL, LPAD(NF.NRNOTAFISC,10,'0'), NF.CDSERIE,
                                     TO_CHAR(NF.DTEMISSAO,'DD')||'/'||TO_CHAR(NF.DTEMISSAO,'MM')||'/'||TO_CHAR(NF.DTEMISSAO,'YYYY'),
                                     NF.IDSTATUS, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')),
                                     DECODE(CL.IDTPIJURCLIE,'F','1','2'), DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'S','N'),
                                     SUBSTR(NVL(P.SGPAIS,P.NMPAIS),1,2), CL.NMRAZSOCCLIE, DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F'))) LOOP

        V_CONTADOR := NVL(V_CONTADOR,0)+1;
        INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
          (LPAD(V_CONTADOR,10,'0'), C_REG_C2.DADOS, P_NRSEQARQMAG);

        UPDATE NOTAFISCAL
           SET IDEXPNFEISS = 'S'
         WHERE CDFILIAL    = C_REG_C2.CDFILIAL
           AND NRLANCTONF  = C_REG_C2.NRLANCTONF;
     END LOOP;

     /*Servio Prestado para Pessoa Jurdica (C|3)*/
     FOR C_REG_C3 IN (SELECT CD_INDICADOR                || '||' ||    NR_LAYOUT                || '||' ||
                             DT_EMISSAO_NF               || '||' ||    NR_DOC_NF_INICIAL        || '||' ||
                             NR_DOC_NF_SERIE             || '||' ||    NR_DOC_NF_FINAL          || '||' ||
                             CASE WHEN IDSTATUS = 'C'      THEN '2'  --Cancelado
                                  WHEN VR_IMP > 0          THEN '1'  --No Retido
                                  WHEN VR_RET > 0          THEN '5'  --Retido
                                  WHEN (VR_IMP+VR_RET) = 0 THEN '4'  --Isento
                             END                         || '||' ||    VL_DOC_NF                || '||' ||
                             ''                          || '||' ||    CD_ATIVIDADE             || '||' ||
                             CD_PREST_TOM_ESTABELECIDO   || '||' ||    CD_LOCAL_PRESTACAO       || '||' ||
                             NM_RAZAO_SOCIAL             || '||' ||    NR_CNPJ_CPF              || '||' ||
                             CD_TIPO_CADASTRO            || '||' ||    NR_INSCRICAO_MUNICIPAL   || '||' ||
                             NM_INSCRICAO_MUNICIPAL_DV   || '||' ||    NR_INSCRICAO_ESTADUAL    || '||' ||
                             NM_TIPO_LOGRADOURO          || '||' ||    NM_TITULO_LOGRADOURO     || '||' ||
                             NM_LOGRADOURO               || '||' ||    NM_COMPL_LOGRADOURO      || '||' ||
                             NR_LOGRADOURO               || '||' ||    CD_CEP                   || '||' ||
                             NM_BAIRRO                   || '||' ||    CD_ESTADO                || '||' ||
                             NM_CIDADE                   || '||' ||    ''                       || '||' ||
                             ''                          || '||' ||    ''                       || '||' ||
                             ''                          || '||' ||    IC_ORIGEM_DADOS          || '||' ||
                             ''                          || '||' ||    ''                       || '||' ||
                             ''                          || '||' ||    ''                       || '||' ||
                             FL_ISENTO                   || '||' ||    ''                       AS DADOS,
                             NRLANCTONF, CDFILIAL
                        FROM (SELECT NF.NRLANCTONF, NF.CDFILIAL, 'C' AS CD_INDICADOR, '3' AS NR_LAYOUT, LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_INICIAL,
                                     NF.CDSERIE AS NR_DOC_NF_SERIE, LPAD(NF.NRNOTAFISC,10,'0') AS NR_DOC_NF_FINAL,
                                     TO_CHAR(NF.DTEMISSAO,'DD')||'/'||TO_CHAR(NF.DTEMISSAO,'MM')||'/'||TO_CHAR(NF.DTEMISSAO,'YYYY') AS DT_EMISSAO_NF,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_S,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_IMP,
                                     SUM(NVL(DECODE(IM.CDIMPOSTONFE,V_ISSQN_RET_S,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_RET,
                                     NF.IDSTATUS, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')) AS VL_DOC_NF,
                                     MAX(CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI)) AS CD_ATIVIDADE, '2' AS CD_TIPO_CADASTRO,
                                     DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'S','N') AS CD_PREST_TOM_ESTABELECIDO,
                                     CL.NMRAZSOCCLIE AS NM_RAZAO_SOCIAL, REPLACE(REPLACE(CL.NRINSMUNICLIE,'ISENTA'),'ISENTO') AS NR_INSCRICAO_MUNICIPAL,
                                     '' AS NM_INSCRICAO_MUNICIPAL_DV, CL.NRINSJURCLIE AS NR_CNPJ_CPF,
                                     CASE WHEN CL.NRINSESTCLIE IS NULL OR NRINSESTCLIE = '' THEN 'S' ELSE 'N' END FL_ISENTO,
                                     REPLACE(REPLACE(CL.NRINSESTCLIE,'ISENTA'),'ISENTO') AS NR_INSCRICAO_ESTADUAL, REPLACE(REPLACE(EC.NRCEPCLIE,'.'),'-') AS CD_CEP,
                                     TRIM(SUBSTR(EC.DSENDECLIE,1,INSTR(EC.DSENDECLIE,' '))) AS NM_TIPO_LOGRADOURO,
                                     TRIM(REPLACE(SUBSTR(EC.DSENDECLIE,INSTR(EC.DSENDECLIE,' '),(INSTR(EC.DSENDECLIE,' ', -1)-INSTR(EC.DSENDECLIE,' '))),',')) AS NM_LOGRADOURO,
                                     TRIM(SUBSTR(EC.DSENDECLIE,INSTR(EC.DSENDECLIE,' ', -1),LENGTH(EC.DSENDECLIE))) AS NR_LOGRADOURO,
                                     '' AS NM_TITULO_LOGRADOURO, EC.DSCOMPENDCLI AS NM_COMPL_LOGRADOURO,
                                     EC.NMBAIRCLIE AS NM_BAIRRO, EC.SGESTADO AS CD_ESTADO, MU.NMMUNICIPIO AS NM_CIDADE,
                                     DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F') AS CD_LOCAL_PRESTACAO, 'R' AS IC_ORIGEM_DADOS
                                FROM LISTA LS, NOTAFISCAL NF, ITEMPROIMPOS IT, IMPOSTO IM, ITEMPRODUTO IP, PRODUTO PR,
                                     CLIENTE CL, ENDECLIE EC, INSCRMUNICIP IC, MUNICIPIO MU
                               WHERE LS.NRLISTA      = P_NRLISTA
                                 AND SUBSTR(LS.CDLISTA,1,4) = NF.CDFILIAL
                                 AND SUBSTR(LS.CDLISTA,5,10)= NF.NRLANCTONF
                                 AND NF.IDENTRSAIDOP = 'S'
                                 AND NF.NRLANCTONF   = IT.NRLANCTONF
                                 AND NF.CDFILIAL     = IT.CDFILIAL
                                 AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                 AND IM.CDIMPOSTONFE IN (V_ISSQN_S, V_ISSQN_RET_S)
                                 AND SUBSTR(IT.CDFISCOPERIT,1,1) <> '7'
                                 AND IT.NRLANCTONF   = IP.NRLANCTONF
                                 AND IT.CDFILIAL     = IP.CDFILIAL
                                 AND IT.NRSEQITPROD  = IP.NRSEQITPROD
                                 AND IP.CDPRODUTO    = PR.CDPRODUTO
                                 AND NF.CDCLIENTE    = CL.CDCLIENTE
                                 AND CL.IDTPIJURCLIE = 'J'
                                 AND NF.CDCLIENTE    = EC.CDCLIENTE
                                 AND EC.IDTPENDECLIE = 'P'
                                 AND NF.CDEMPRESA    = IC.CDEMPRESA
                                 AND NF.CDINSCMUNI   = IC.CDINSCMUNI
                                 AND EC.CDPAIS       = MU.CDPAIS
                                 AND EC.SGESTADO     = MU.SGESTADO
                                 AND EC.CDMUNICIPIO  = MU.CDMUNICIPIO
                               GROUP BY NF.NRLANCTONF, NF.CDFILIAL, LPAD(NF.NRNOTAFISC,10,'0'), NF.CDSERIE,
                                        TO_CHAR(NF.DTEMISSAO,'DD')||'/'||TO_CHAR(NF.DTEMISSAO,'MM')||'/'||TO_CHAR(NF.DTEMISSAO,'YYYY'),
                                        NF.IDSTATUS, TRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC,'9999999990.00'),'.')),
                                        DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'S','N'), CL.NMRAZSOCCLIE, CL.NRINSMUNICLIE,
                                        CL.NRINSJURCLIE, CASE WHEN CL.NRINSESTCLIE IS NULL OR NRINSESTCLIE = '' THEN 'S' ELSE 'N' END,
                                        CL.NRINSESTCLIE, EC.NRCEPCLIE, EC.DSCOMPENDCLI,
                                        TRIM(SUBSTR(EC.DSENDECLIE,1,INSTR(EC.DSENDECLIE,' '))),
                                        TRIM(REPLACE(SUBSTR(EC.DSENDECLIE,INSTR(EC.DSENDECLIE,' '),(INSTR(EC.DSENDECLIE,' ', -1)-INSTR(EC.DSENDECLIE,' '))),',')),
                                        TRIM(SUBSTR(EC.DSENDECLIE,INSTR(EC.DSENDECLIE,' ', -1),LENGTH(EC.DSENDECLIE))),
                                        EC.NMBAIRCLIE, EC.SGESTADO, MU.NMMUNICIPIO, DECODE(EC.CDMUNICIPIO,IC.CDMUNICIPIO,'D','F'))) LOOP

        V_CONTADOR := NVL(V_CONTADOR,0)+1;
        INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
          (LPAD(V_CONTADOR,10,'0'), C_REG_C3.DADOS, P_NRSEQARQMAG);

        UPDATE NOTAFISCAL
           SET IDEXPNFEISS = 'S'
         WHERE CDFILIAL    = C_REG_C3.CDFILIAL
           AND NRLANCTONF  = C_REG_C3.NRLANCTONF;
     END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GISS_ONLINE','5.65.000'); END;
/

